#!/usr/bin/env python

import gi
import os
import signal
import time
gi.require_version('Gtk', '3.0')
gi.require_version('AppIndicator3', '0.1')

from gi.repository import Gtk as gtk
from gi.repository import AppIndicator3 as appindicator


APPINDICATOR_ID = 'appindicator_forLA2'

f2 = open('/tmp/ppid_LAII.txt' , 'r')
pid_LA2 = f2.read()
f2.close()


def main():
    ##indicator = appindicator.Indicator.new(APPINDICATOR_ID, os.path.abspath('./linuxaction.svg'), appindicator.IndicatorCategory.SYSTEM_SERVICES)
    indicator = appindicator.Indicator.new(APPINDICATOR_ID, os.path.abspath('/usr/share/icons/hicolor/scalable/apps/linuxaction.svg'), appindicator.IndicatorCategory.SYSTEM_SERVICES)
    indicator.set_status(appindicator.IndicatorStatus.ACTIVE)
    indicator.set_menu(build_menu())
    
    os.system("echo 2022-07-01: LA2 start app indicator")

    path = '/tmp/.LA2_indicatorpid.txt'
    pid = os.getpid()
    f = open(path , 'w')
    f.write("%d" % pid)
    f.close()


    gtk.main()



def build_menu():
    menu = gtk.Menu()
    ##Quit btn
    item_quit = gtk.MenuItem('Quit Linux Action')
    item_quit.connect('activate', quit)
    ##Show btn
    item_show = gtk.MenuItem('Open')
    item_show.connect('activate' , show )
    ##Seprator
    menu_sep = gtk.SeparatorMenuItem()

    menu.append(item_show)
    menu.append(menu_sep)
    menu.append(item_quit)

    menu.show_all()
    return menu

def quit(source):
    try:
        os.kill(int(pid_LA2),signal.SIGRTMIN+4)
        os.system("echo send quit signal")
    except OSError:
        gtk.main_quit()


def show(source):

    os.kill(int(pid_LA2),signal.SIGRTMIN+5)
    os.system("echo show LA2 UI")

def handler(signum, frame):
    os.system("echo get sig from LA2")
    time.sleep(0.5)
    os.system("rm /tmp/.LA2_indicatorpid.txt")
    gtk.main_quit()


if __name__ == "__main__":
    signal.signal(signal.SIGINT, signal.SIG_DFL)
    signal.signal(signal.SIGRTMIN+6 , handler)
    main()
